	PROGRAM euler3

!********************************************************
!	Solves the ordinary differential equation dx/dt=-omega²*x
!	with the explicit euler algorithm and heun's method
!       Plot in Dislin
!       Compile with dlink -c euler3
!********************************************************
	PARAMETER(T=70, DT=0.05, IDIM=T/DT)	
	DIMENSION TRAY(IDIM),YEULERRAY(IDIM),YHEUNRAY(IDIM)
	DIMENSION XEULERRAY(IDIM),XHEUNRAY(IDIM)
	
	Write(6,*) 'Gib x(t=0) und dx(t=0)/dt ein'
	
	
!       Initial value of X
	READ(5,*) X
	READ(5,*) Y
	XEULERRAY(1)=X
	XHEUNRAY(1)=X

	YEULERRAY(1)=Y
	YHEUNRAY(1)=Y

	DO I=1, IDIM
	 TRAY(I)=DT*I	 
	 XEULERRAY(I+1)=XEULERRAY(I)+YEULERRAY(I)*DT
	 YEULERRAY(I+1)=YEULERRAY(I)-0.5*XEULERRAY(I)*DT
	 WRITE(6,*) XEULERRAY(I)
         XHEUNRAY(I+1)=XHEUNRAY(I)+(YHEUNRAY(I)+YHEUNRAY(I+1))*DT/2.
	 YHEUNRAY(I+1)=YHEUNRAY(I)-0.5*(XHEUNRAY(I)+XHEUNRAY(I+1))*DT/2.
C	 WRITE(6,*) TRAY(I)

	ENDDO
	
	CALL PLOT(TRAY,XEULERRAY,XHEUNRAY,IDIM,T)
	
		
	
	STOP
	END

!****************************************

!	X-t Diagramm

      SUBROUTINE PLOT(TRAY,XEULERRAY,XHEUNRAY,IDIM,T)
		
      DIMENSION TRAY(IDIM),XEULERRAY(IDIM),XHEUNRAY(IDIM)
      CALL SCRMOD('REVERS')	
      CALL METAFL('XWIN')
      CALL DISINI
      CALL PAGERA
      CALL COMPLX
      
      CALL AXSPOS(450,1800)
      CALL AXSLEN(2200,1200)

      CALL NAME('X-axis','X')
      CALL NAME('Y-axis','Y')
	
      

      CALL TITLIN('DX/DT=t-X**2',1)

  

      CALL GRAF(0.,T,0.,T/10.,-5.,5.,-5.,1.)
     

      CALL COLOR('FORE') 
      CALL HEIGHT(50)
      CALL TITLE

      CALL INCMRK(-20)
      CALL MARKER(31)
      CALL HSYMBL(20)
      CALL COLOR('RED')
      CALL CURVE(TRAY,XEULERRAY,IDIM)
      CALL COLOR('GREEN')
      CALL CURVE(TRAY,XHEUNRAY,IDIM)
      CALL DISFIN
      
      RETURN
      END

