	PROGRAM wettbewerb

!********************************************************
!	Solves the ordinary differential equation system
!	dx/dt=ax(b-x-cy)
!       dy/dt=dy(e-y-fx)
!	with runge-kutta 4
!       Plot in Dislin
!       Compile with dlink -c wettbewerb
!       Date: 06. März 2011
!********************************************************
	PARAMETER(T=300, DT=0.005, IDIM=INT(T/DT))	
	DIMENSION TRAY(IDIM)
	DIMENSION XRUNGE(IDIM),YRUNGE(IDIM)
	

!       Setting the parameters
	VARA=0.004
	VARB=50.
	VARC=0.75
	VARD=0.001
	VARE=100.
	VARF=3.


	Write(6,*) 'Gib x(t=0) und y(t=0) ein'
	
	
!       Initial value of X
	READ(5,*) X
	READ(5,*) Y

	XRUNGE(1)=X
	YRUNGE(1)=Y


	DO I=1, IDIM
	 TRAY(I)=DT*I	 
	 
	 XRUNGE(I)=X
	 YRUNGE(I)=Y
	 XKEINS=FUNCX(X,Y,VARA,VARB,VARC)*DT
	 YKEINS=FUNCY(X,Y,VARD,VARE,VARF)*DT

	 XKZWEI=FUNCX(X+0.5*XKEINS,Y+0.5*YKEINS,VARA,VARB,VARC)*DT
	 YKZWEI=FUNCY(X+0.5*XKEINS,Y+0.5*YKEINS,VARD,VARE,VARF)*DT

	 XKDREI=FUNCX(X+0.5*XKZWEI,Y+0.5*YKZWEI,VARA,VARB,VARC)*DT
	 YKDREI=FUNCY(X+0.5*XKZWEI,Y+0.5*YKZWEI,VARD,VARE,VARF)*DT

         XKVIER=FUNCX(X+XKDREI,Y+YKDREI,VARA,VARB,VARC)*DT
	 YKVIER=FUNCY(X+XKDREI,Y+YKDREI,VARD,VARE,VARF)*DT


         X=X+(XKEINS+2.*XKZWEI+2.*XKDREI
     &               +XKVIER)/6.
	 Y=Y+(YKEINS+2.*YKZWEI+2.*YKDREI
     &               +YKVIER)/6.

	ENDDO
	
	CALL PLOT(TRAY,XRUNGE,YRUNGE,IDIM,T)
	
		
	
	STOP
	END

!****************************************

	REAL FUNCTION FUNCX(X,Y,VARA,VARB,VARC)
	
	FUNCX=VARA*X*(VARB-X-VARC*Y)
	RETURN 
	END 

!****************************************

	REAL FUNCTION FUNCY(X,Y,VARD,VARE,VARF)
	
	FUNCY=VARD*Y*(VARE-Y-VARF*X)
	RETURN
	END 
!****************************************
!	X-t Diagramm

       SUBROUTINE PLOT(TRAY,XRUNGE,YRUNGE,IDIM,T)
		
       DIMENSION TRAY(IDIM),YRUNGE(IDIM),XRUNGE(IDIM)
      
       CALL METAFL('XWIN')
       CALL DISINI
       CALL PAGERA
       CALL COMPLX
 
       CALL AXSPOS(450,1800)
       CALL AXSLEN(2200,1200)

       CALL NAME('X-axis','X')
       CALL NAME('Y-axis','Y')
 
      

       CALL TITLIN('DX/DT=t-X**2',1)

  

       CALL GRAF(0.,T,0.,T/10.,-10.,110.,-10.,10.)
     

       CALL COLOR('FORE') 
       CALL HEIGHT(50)
       CALL TITLE

       CALL INCMRK(-20)
       CALL MARKER(21)
       CALL HSYMBL(1)
       CALL COLOR('RED')
       CALL CURVE(TRAY,XRUNGE,IDIM)
       CALL COLOR('GREEN')
       CALL CURVE(TRAY,YRUNGE,IDIM)
       CALL DISFIN
      
       RETURN
       END

